//+------------------------------------------------------------------+
//|                                                        EVWMA.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  LimeGreen
#property indicator_width1  2

extern int                Length=14;
extern ENUM_APPLIED_PRICE Price = PRICE_CLOSE;
double EVWMA[];
double V[];

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,EVWMA);
   SetIndexBuffer(1,V);
   IndicatorShortName("Elastic Volume Weighted Moving Average");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMax(Bars-counted_bars,Bars-1);

      for(int i=limit; i >= 0; i--) V[i]=Volume[i];
      for(    i=limit; i >= 0; i--)
      {
         double Total=iMAOnArray(V,0,Length,0,MODE_SMA,i)*Length;
         if (Total!=0)
               EVWMA[i]=((Total-Volume[i])*EVWMA[i+1]+Volume[i]*iMA(NULL,0,1,0,MODE_SMA,Price,i))/Total;
         else  EVWMA[i]=0;
      }  
      return(0);
}